--[[ 	GupPet by Gup 	]]--

-- TEMP VARS
GUPPET_INTERFACE_LOCATIONFRAME 	= { Total = 0} ;
GUPPET_INTERFACE_MAINFRAME 		= { Init = 0 , SlowGround = { Temp = 0} , SlowFly = {Temp = 0} , FastGround = {Temp = 0} , FastFly = {Temp = 0}, Aquatic = {Temp = 0} , Companion = {Temp = 0} } ;
GUPPET_INTERFACE_OPTIONFRAME 		= { Init = 0} ;
GUPPET_INTERFACE_SAVEHIGHLIGHT 	= {} ;
GUPPET_INTERFACE_INGAMEBUTTONS 	= { Init = 0};
GUPPET_INTERFACE_SAVESHOW = {}

-- Popups
StaticPopupDialogs["GupPet_Interface_Remove"] = {
  text = GUPPET_L["INTERFACE_REMOVE"][1] ,
  button1 = GUPPET_L["INTERFACE_REMOVE"][2],
  button2 = GUPPET_L["INTERFACE_REMOVE"][3],
  OnAccept = function()
        GupPet_Location( "Remove" , GupPet_Interface_GetLocationSelected() );
		GupPet_Interface_UpdateLocationFrame() ;
  end,
  timeout = 0,
  whileDead = 1,
  hideOnEscape = 1
};

StaticPopupDialogs["GupPet_Interface_ChangeMode"] = {
  text = GUPPET_L["INTERFACE_CHANGEMODE"][1] ,
  button1 = GUPPET_L["INTERFACE_CHANGEMODE"][2],
  button2 = GUPPET_L["INTERFACE_CHANGEMODE"][3],
  OnAccept = function()
        
		if GUPPET_OPTIONS.Mode == "Expert" then
			GUPPET_OPTIONS.Mode = "_Expert"
		else
			GUPPET_OPTIONS.Mode = "Expert"
		end
		ReloadUI() ;
  end,
  OnCancel = function()
 		GUPPET_INTERFACE_OPTIONFRAME.ExpertMode:SetChecked(  GUPPET_OPTIONS.Mode == "Expert" ); 
  end,
  timeout = 0,
  whileDead = 1,
  hideOnEscape = 1
};


-- Add , Show
function GupPet_Interface_Show( Type , Option , frame )

	if Option == "Add" then
		if GUPPET_INTERFACE_SAVESHOW[Type] == nil then GUPPET_INTERFACE_SAVESHOW[Type] = {} ; end
			
		tinsert( GUPPET_INTERFACE_SAVESHOW[Type] , frame:GetName() ) ;
	else
		ShowFrame = frame:GetName()
		
		for i , SavedFrame  in  ipairs(GUPPET_INTERFACE_SAVESHOW[Type])  do 
		
			if SavedFrame == ShowFrame then
				getglobal( SavedFrame  ):Show();
			else
				getglobal( SavedFrame  ):Hide();
			end
		end
	end
end
 
function GupPet_Interface_SetSelected( Button , Type )
		
	if not( GUPPET_INTERFACE_SAVEHIGHLIGHT[Type] == nil) then
		getglobal( GUPPET_INTERFACE_SAVEHIGHLIGHT[Type] ):UnlockHighlight();
	end
	
	Button:LockHighlight() ;
	GUPPET_INTERFACE_SAVEHIGHLIGHT[Type] = Button:GetName();
end


function GupPet_Interface_GetSelected( Type )

	return GUPPET_INTERFACE_SAVEHIGHLIGHT[Type] ;

end

function GupPet_Interface_BuildMacro( self, option )

	-- To avoid errors
	if InCombatLockdown() then return end 

	
	--[[
		MAGE 
	]]
	if GUPPET_TEMPCLASSDATA.Type == "MAGE" and option ~= "FLY"  then
	
		if  GUPPET_TEMPCLASSDATA["SlowFall"]["Usable"] then
			self:SetAttribute("alt-macrotext1", "/use "..GUPPET_TEMPCLASSDATA["SlowFall"]["Name"] );
		end
	
		if GUPPET_OPTIONS["Class"]["SlowFallOnFalling"] and GUPPET_TEMPCLASSDATA["SlowFall"]["Usable"]  and IsFalling() and not (IsMounted() or UnitInVehicle("player")) then
			self:SetAttribute("macrotext"		, "/use "..GUPPET_TEMPCLASSDATA["SlowFall"]["Name"] ) ;
			return 
		end
	end

	--[[
		HUNTER --> 	If you are in a place and you cant mount or you are running pop your aspect on. 
					When you are in a grp put that one on
			Always under ALT modifier Pack or Cheetah
	]]
	if GUPPET_TEMPCLASSDATA.Type == "HUNTER" and  option ~= "FLY"  then
					
		if GUPPET_TEMPCLASSDATA["Pack"]["Usable"] and GetNumPartyMembers() > 0 then
			self:SetAttribute("alt-macrotext1", "/use "..GUPPET_TEMPCLASSDATA["Pack"]["Name"] );
		elseif GUPPET_TEMPCLASSDATA["Cheetah"]["Usable"]  then	
			self:SetAttribute("alt-macrotext1", "/use "..GUPPET_TEMPCLASSDATA["Cheetah"]["Name"] );
		end
		 		
	end
	
	--[[
		DRUID --> 
			Druid fly if you can fly
			Normal mount if you can mount it 
			Always under ALT modifier travelform
	]]
	if GUPPET_TEMPCLASSDATA.Type == "DRUID"   then
	
		if GUPPET_TEMPCLASSDATA["Travel"]["Usable"] then
			self:SetAttribute("alt-macrotext1", "/cancelform\n/use "..GUPPET_TEMPCLASSDATA["Travel"]["Name"] );
		end
	
		if option == "FLY" then
		
			if (GUPPET_OPTIONS["Class"]["FlyForm"] or IsFalling() ) and GUPPET_TEMPCLASSDATA["FastFly"]["Usable"] then
			
				self:SetAttribute("macrotext"		, "/use "..GUPPET_TEMPCLASSDATA["FastFly"]["Name"] );
				self:SetAttribute("shift-macrotext1", "/use "..GUPPET_TEMPCLASSDATA["FastFly"]["Name"] );
				self:SetAttribute("alt-macrotext1"	, "/use "..GUPPET_TEMPCLASSDATA["FastFly"]["Name"] );
			
			elseif (GUPPET_OPTIONS["Class"]["FlyForm"] or IsFalling() ) and GUPPET_TEMPCLASSDATA["SlowFly"]["Usable"] then
			
				self:SetAttribute("macrotext"		, "/use "..GUPPET_TEMPCLASSDATA["SlowFly"]["Name"] );
				self:SetAttribute("shift-macrotext1", "/use "..GUPPET_TEMPCLASSDATA["SlowFly"]["Name"] );
				self:SetAttribute("alt-macrotext1"	, "/use "..GUPPET_TEMPCLASSDATA["SlowFly"]["Name"] );
			else
				self:SetAttribute("macrotext"		, "/cancelform\n/script GupPet_AutoFly()" );
				self:SetAttribute("shift-macrotext1", "/cancelform\n/script GupPet_AutoFly()" );
				self:SetAttribute("alt-macrotext1"	, "/cancelform\n/script GupPet_AutoFly()" );
			end
			return 
			
		elseif option == "GROUND" then
			
			if IsSwimming() and GUPPET_TEMPCLASSDATA["Aquatic"]["Usable"] and GUPPET_OPTIONS["Class"]["AquaticForm"] then
				self:SetAttribute("macrotext"		, "/use "..GUPPET_TEMPCLASSDATA["Aquatic"]["Name"] )
				self:SetAttribute("shift-macrotext1", "/use "..GUPPET_TEMPCLASSDATA["Aquatic"]["Name"] )
				
			elseif GetUnitSpeed("player") > 0 and GUPPET_TEMPCLASSDATA["Travel"]["Usable"] and GUPPET_OPTIONS["Class"]["TravelOnFormWalking"] then
				self:SetAttribute("macrotext"		, "/use "..GUPPET_TEMPCLASSDATA["Travel"]["Name"] )
				self:SetAttribute("shift-macrotext1", "/use "..GUPPET_TEMPCLASSDATA["Travel"]["Name"] )
			else
				self:SetAttribute("macrotext"		, "/cancelform\n/script GupPet_AutoGround()" )
				self:SetAttribute("shift-macrotext1", "/cancelform\n/script GupPet_AutoGround()" )
			end
					
			return
		
		else
		
			if GetUnitSpeed("player") > 0 and GUPPET_TEMPCLASSDATA["Travel"]["Usable"] and GUPPET_OPTIONS["Class"]["TravelOnFormWalking"] then
				self:SetAttribute("shift-macrotext1", "/use "..GUPPET_TEMPCLASSDATA["Travel"]["Name"] )
			else
				self:SetAttribute("shift-macrotext1", "/cancelform\n/script GupPet_AutoGround()" )
			end
		
		
			if GupPet_CanFly() then 	
				
				if (GUPPET_OPTIONS["Class"]["FlyForm"] or IsFalling() ) and GUPPET_TEMPCLASSDATA["FastFly"]["Usable"] then
			
					self:SetAttribute("macrotext"		, "/use "..GUPPET_TEMPCLASSDATA["FastFly"]["Name"] )

				elseif (GUPPET_OPTIONS["Class"]["FlyForm"] or IsFalling() ) and GUPPET_TEMPCLASSDATA["SlowFly"]["Usable"] then
				
					self:SetAttribute("macrotext"		, "/use "..GUPPET_TEMPCLASSDATA["SlowFly"]["Name"] )
				else
					self:SetAttribute("macrotext"		, "/cancelform\n/script GupPet_AutoMounten()" )
				end
				return
			
			elseif IsSwimming() and GUPPET_TEMPCLASSDATA["Aquatic"]["Usable"] and GUPPET_OPTIONS["Class"]["AquaticForm"] then
				
				self:SetAttribute("macrotext"		, "/use "..GUPPET_TEMPCLASSDATA["Aquatic"]["Name"] )
				self:SetAttribute("shift-macrotext1", "/use "..GUPPET_TEMPCLASSDATA["Aquatic"]["Name"] )
				 
			elseif GetUnitSpeed("player") > 0 and GUPPET_TEMPCLASSDATA["Travel"]["Usable"] and GUPPET_OPTIONS["Class"]["TravelOnFormWalking"] then
				
				self:SetAttribute("macrotext"		, "/use "..GUPPET_TEMPCLASSDATA["Travel"]["Name"] )

			else
				self:SetAttribute("macrotext"		, "/cancelform\n/script GupPet_AutoGround()" )
			end
 
 
			return


		end

	end

	--[[
		SHAMAN --> If you are in a place where you cant mount or you are running ( if its instant ) 
			Always under ALT modifier 
	]]
	if GUPPET_TEMPCLASSDATA.Type == "SHAMAN" and  option ~= "FLY"  then
	
		if GUPPET_TEMPCLASSDATA["Ghost"]["Usable"] then
			self:SetAttribute("alt-macrotext1", "/use "..GUPPET_TEMPCLASSDATA["Ghost"]["Name"] );
		end
		
		if GUPPET_TEMPCLASSDATA["Ghost"]["Usable"] and  GetUnitSpeed("player") > 0 and ( option == "GROUND" or option == "AUTO" )and  GUPPET_OPTIONS["Class"]["GhostWolfOnWalking"]  then

			self:SetAttribute("macrotext"		, "/use "..GUPPET_TEMPCLASSDATA["Ghost"]["Name"] )
			self:SetAttribute("shift-macrotext1", "/script GupPet_AutoGround()" )
			return
		end
	end
	
	if option == "GROUND" then
		self:SetAttribute("macrotext"		, "/script GupPet_AutoGround()" )
		self:SetAttribute("shift-macrotext1", "/script GupPet_AutoGround()" )
	
	elseif option == "FLY" then
	
		self:SetAttribute("macrotext"		, "/script GupPet_AutoFly()" )
		self:SetAttribute("shift-macrotext1", "/script GupPet_AutoFly()" )
		self:SetAttribute("alt-macrotext1"	, "/script GupPet_AutoFly()" )
	
			
	
	else
				
		self:SetAttribute("macrotext"		, "/script GupPet_AutoMounten()" );
		self:SetAttribute("shift-macrotext1", "/script GupPet_AutoGround()" )
	end
	
	--[[
		If your not a druid / mage / hunter / shaman kill calling of this function
	]]
	if not (GUPPET_TEMPCLASSDATA.Type == "MAGE" or GUPPET_TEMPCLASSDATA.Type == "SHAMAN" or GUPPET_TEMPCLASSDATA.Type == "DRUID" or GUPPET_TEMPCLASSDATA.Type == "HUNTER") then
	
		self:SetScript("PreClick", function (self, button, down)  end) ; 
	end
	
end
 

 
 function GupPet_Interface_MakeButtons()
 
	local GupPet_PetPaperDoll_Button = CreateFrame("Button", "GupPet_PetPaperDoll_Button", PetPaperDollFrame , "GupPet_SmallButtonTemplate" );
	GupPet_PetPaperDoll_Button:SetScript("OnClick", function ()
			
			if GupPet_InterfaceOptionsFrame and GupPet_InterfaceOptionsFrame:IsShown() then	
				
				HideUIPanel(GupPet_InterfaceOptionsFrame);
			else	
				ShowUIPanel(GupPet_InterfaceOptionsFrame); 
			end
		end) ;
	GupPet_PetPaperDoll_Button:SetPoint("TOPRIGHT" ,-40 , -40 );
	GupPet_PetPaperDoll_Button.tooltipText = "GupPet";
	
	
	
	local Optionframe = CreateFrame( "Frame", "GupPetPanel" , nil ); 
	Optionframe.name = "GupPet";
		
	local Optionframe_Button = CreateFrame("Button", "GupPet_OptionButton", Optionframe , "GupPet_ButtonTemplate");
	Optionframe_Button:SetScript("OnClick", function ()  ShowUIPanel(GupPet_InterfaceOptionsFrame); end) ;
	Optionframe_Button:SetWidth(200); 
	Optionframe_Button:SetHeight(30); 
	Optionframe_Button:SetPoint("CENTER", 0, 0);
	Optionframe_Button:SetText( "GupPet" );
	 
	InterfaceOptions_AddCategory(Optionframe);
 
 end
 
function GupPet_Interface_DragIngameButtons( option )

	if option == "Reset" then
	
		GUPPET_INTERFACE_INGAMEBUTTONS.Frame:ClearAllPoints(); 
		GUPPET_INTERFACE_INGAMEBUTTONS.Frame:SetPoint("CENTER",0, 0);   
		_, _, GUPPET_OPTIONS.IngameButton.RelativePoint, GUPPET_OPTIONS.IngameButton.xOffset, GUPPET_OPTIONS.IngameButton.yOffset = GUPPET_INTERFACE_INGAMEBUTTONS.Frame:GetPoint()

	elseif option == "Show" then

	getglobal("GupPet_IngameFrameTemplate".."MoveTopLeft"  ):Show();
	getglobal("GupPet_IngameFrameTemplate".."MoveTopRight"  ):Show();
	getglobal("GupPet_IngameFrameTemplate".."MoveBottomLeft"  ):Show();
	getglobal("GupPet_IngameFrameTemplate".."MoveBottomRight"  ):Show();

	elseif option == "Hide" then

	getglobal("GupPet_IngameFrameTemplate".."MoveTopLeft"  ):Hide();
	getglobal("GupPet_IngameFrameTemplate".."MoveTopRight"  ):Hide();
	getglobal("GupPet_IngameFrameTemplate".."MoveBottomLeft"  ):Hide();
	getglobal("GupPet_IngameFrameTemplate".."MoveBottomRight"  ):Hide();
	
	elseif option == "Start" then
		GUPPET_INTERFACE_INGAMEBUTTONS.Frame:SetMovable( true ) ;
		GUPPET_INTERFACE_INGAMEBUTTONS.Frame:StartMoving();
	else
		GUPPET_INTERFACE_INGAMEBUTTONS.Frame:StopMovingOrSizing() ;
		GUPPET_INTERFACE_INGAMEBUTTONS.Frame:SetMovable( false ) ;
		
		_, _, GUPPET_OPTIONS.IngameButton.RelativePoint, GUPPET_OPTIONS.IngameButton.xOffset, GUPPET_OPTIONS.IngameButton.yOffset = GUPPET_INTERFACE_INGAMEBUTTONS.Frame:GetPoint()
	end

end

function GupPet_Interface_UpdateHotkeysIngameButtons (self , actie )

	local hotkey = _G[self:GetName().."HotKey"];
    local key = GetBindingKey( actie );

	local text = GetBindingText(key, "KEY_", 1);
    if ( text == "" ) then
        hotkey:SetText(RANGE_INDICATOR);
        hotkey:SetPoint("TOPLEFT", self, "TOPLEFT", 1, -2);
        hotkey:Hide();
    else
        hotkey:SetText(text);
        hotkey:SetPoint("TOPLEFT", self, "TOPLEFT", -2, -2);
        hotkey:Show();
    end
end


function GupPet_Interface_IngameButtons()

	if GUPPET_INTERFACE_INGAMEBUTTONS.Init == 0  then
	
		GUPPET_INTERFACE_INGAMEBUTTONS.Frame = CreateFrame("FRAME", "GupPet_IngameFrameTemplate", UIParent , "GupPet_IngameFrameTemplate" );   
		GUPPET_INTERFACE_INGAMEBUTTONS.Frame:SetWidth(32);
		GUPPET_INTERFACE_INGAMEBUTTONS.Frame:SetHeight(32);
		GUPPET_INTERFACE_INGAMEBUTTONS.Frame:SetClampedToScreen( true ) ; 

		GUPPET_INTERFACE_INGAMEBUTTONS.Init = 1 ;
	end

	GUPPET_INTERFACE_INGAMEBUTTONS.Frame:SetPoint( GUPPET_OPTIONS.IngameButton.RelativePoint , GUPPET_OPTIONS.IngameButton.xOffset , GUPPET_OPTIONS.IngameButton.yOffset );
	GUPPET_INTERFACE_INGAMEBUTTONS.Frame:SetScale( GUPPET_OPTIONS.IngameButton.Scale );
	
	local buttonNr = 0 ;

	getglobal("GupPet_IngameFrameTemplateAuto"):Hide();
	getglobal("GupPet_IngameFrameTemplateGround"):Hide() ;
	getglobal("GupPet_IngameFrameTemplateFly"):Hide() ;
	getglobal("GupPet_IngameFrameTemplateCompanion"):Hide() ;
	
	
	if GUPPET_OPTIONS.IngameButton.MountButton == "Auto" and GUPPET_Z["SUPPORT"] and ( GUPPET_SAVEDDATA[ "SlowFly" ]["Total"] > 0 or GUPPET_SAVEDDATA[ "FastFly" ]["Total"] > 0 or (GUPPET_TEMPCLASSDATA.Type == "DRUID" and( GUPPET_TEMPCLASSDATA["FastFly"]["Usable"] or GUPPET_TEMPCLASSDATA["SlowFly"]["Usable"] )) ) then
				
			buttonNr = buttonNr + 1 ;
			getglobal("GupPet_IngameFrameTemplateAuto"):Show() ;
	else
		if GUPPET_SAVEDDATA[ "SlowGround" ]["Total"] > 0 or GUPPET_SAVEDDATA[ "FastGround" ]["Total"] > 0 then
		
			buttonNr = buttonNr + 2 ;
			getglobal("GupPet_IngameFrameTemplateGround"):Show() ;
		end
		
		if GUPPET_SAVEDDATA[ "SlowFly" ]["Total"] > 0 or GUPPET_SAVEDDATA[ "FastFly" ]["Total"] > 0  or (GUPPET_TEMPCLASSDATA.Type == "DRUID" and( GUPPET_TEMPCLASSDATA["FastFly"]["Usable"] or GUPPET_TEMPCLASSDATA["SlowFly"]["Usable"] )) then
		
			buttonNr = buttonNr + 4 ;
			getglobal("GupPet_IngameFrameTemplateFly"):Show() ;
		end
	end
		
	if GUPPET_OPTIONS.IngameButton.CompanionButton and GUPPET_SAVEDDATA.Companion.Total > 0 then
	
		buttonNr = buttonNr + 8 ;
		getglobal("GupPet_IngameFrameTemplateCompanion"):Show() ;
	end
	
	
	if buttonNr == 1 then -- Auto
	
		getglobal("GupPet_IngameFrameTemplateAuto"):SetPoint("CENTER",0,0);
		GUPPET_INTERFACE_INGAMEBUTTONS.Frame:SetWidth(32);
		
	elseif buttonNr == 2 then -- Ground 

		getglobal("GupPet_IngameFrameTemplateGround"):SetPoint("CENTER",0,0);
		GUPPET_INTERFACE_INGAMEBUTTONS.Frame:SetWidth(32);
	
	elseif buttonNr == 6 then	-- Ground + Fly
	
		getglobal("GupPet_IngameFrameTemplateGround"):SetPoint("CENTER",-17.5,0);
		getglobal("GupPet_IngameFrameTemplateFly"):SetPoint("CENTER",17.5,0);
		GUPPET_INTERFACE_INGAMEBUTTONS.Frame:SetWidth(67);
				
	elseif buttonNr == 8 then -- Companion
	
		getglobal("GupPet_IngameFrameTemplateCompanion"):SetPoint("CENTER",0,0);
		GUPPET_INTERFACE_INGAMEBUTTONS.Frame:SetWidth(32);		

	elseif buttonNr == 9 then -- Auto + Companion
	
		getglobal("GupPet_IngameFrameTemplateAuto"):SetPoint("CENTER",-17.5,0) ;
		getglobal("GupPet_IngameFrameTemplateCompanion"):SetPoint("CENTER",17.5,0);	
		GUPPET_INTERFACE_INGAMEBUTTONS.Frame:SetWidth(67);		
	
	elseif buttonNr == 10 then -- grond + Companion

		getglobal("GupPet_IngameFrameTemplateGround"):SetPoint("CENTER",-17.5,0) ;
		getglobal("GupPet_IngameFrameTemplateCompanion"):SetPoint("CENTER",17.5,0);	
		GUPPET_INTERFACE_INGAMEBUTTONS.Frame:SetWidth(67);
	
	elseif buttonNr == 14 then
	
		getglobal("GupPet_IngameFrameTemplateGround"):SetPoint("CENTER",-35,0);
		getglobal("GupPet_IngameFrameTemplateFly"):SetPoint("CENTER",0,0);
		getglobal("GupPet_IngameFrameTemplateCompanion"):SetPoint("CENTER",35,0);	
		GUPPET_INTERFACE_INGAMEBUTTONS.Frame:SetWidth(102); 
	end
	
	
	
	if GUPPET_OPTIONS["IngameButton"]["Show"] then
		GUPPET_INTERFACE_INGAMEBUTTONS.Frame:Show() ;
	else
		GUPPET_INTERFACE_INGAMEBUTTONS.Frame:Hide() ;
		GUPPET_OPTIONS["IngameButton"]["Show"] = false ;
	end
	
	if GUPPET_OPTIONS["IngameButton"]["Lock"] then 
		GupPet_Interface_DragIngameButtons( "Hide" ) 
	else 
		GupPet_Interface_DragIngameButtons( "Show" ) 
	end
	
	GupPet_Interface_UpdateHotkeysIngameButtons( getglobal("GupPet_IngameFrameTemplateAuto")		, "GUPPET_AUTO" );
	GupPet_Interface_UpdateHotkeysIngameButtons( getglobal("GupPet_IngameFrameTemplateGround") 		, "GUPPET_AUTOGROUND" );
	GupPet_Interface_UpdateHotkeysIngameButtons( getglobal("GupPet_IngameFrameTemplateFly") 		, "GUPPET_AUTOFLY" );
	GupPet_Interface_UpdateHotkeysIngameButtons( getglobal("GupPet_IngameFrameTemplateCompanion") 	, "GUPPET_CALLCOMPANION" )
	

end

--  
function GupPet_Interface_Option()
	
	if GUPPET_INTERFACE_OPTIONFRAME.Init == 0 then
	
		-- SlashCommands
		GUPPET_INTERFACE_OPTIONFRAME.SlashFrame = CreateFrame("FRAME", "GupPet_SlashFrame", GupPet_InterfaceOptionsFrameOptions , "GupPet_FieldTemplate");
 		GUPPET_INTERFACE_OPTIONFRAME.SlashFrame:SetWidth(660);
		GUPPET_INTERFACE_OPTIONFRAME.SlashFrame:SetHeight(145);	
		GUPPET_INTERFACE_OPTIONFRAME.SlashFrame:SetPoint("BOTTOMLEFT", 10 , 10);
		getglobal("GupPet_SlashFrame" .. "SubTitle"):SetText("|cFFFC830E".. GUPPET_L["SLASHCOMMANDS"][1]) ;	
				
		GUPPET_INTERFACE_OPTIONFRAME.SlashCommands = CreateFrame("SimpleHTML", "GupPet_Slash" , GUPPET_INTERFACE_OPTIONFRAME.SlashFrame );
		GUPPET_INTERFACE_OPTIONFRAME.SlashCommands:SetWidth(640); 
		GUPPET_INTERFACE_OPTIONFRAME.SlashCommands:SetHeight(50); 
		GUPPET_INTERFACE_OPTIONFRAME.SlashCommands:SetPoint("TOPLEFT", 10 , -10);
		GUPPET_INTERFACE_OPTIONFRAME.SlashCommands:SetText("<html><body><p>"..
															GUPPET_S["SLASH"].."<br /><br />"..
															
															"'"..GUPPET_S["SLOWGROUNDMOUNT"][1] 	.."'"..	GUPPET_S["USE"]	.."'".. GUPPET_S["SLOWGROUNDMOUNT"][2] 	.."' ".. GUPPET_S["SLOWGROUNDMOUNT"][3] .."<br />"..
															"'"..GUPPET_S["FASTGROUNDMOUNT"][1] 	.."'"..	GUPPET_S["USE"]	.."'".. GUPPET_S["FASTGROUNDMOUNT"][2] 	.."' ".. GUPPET_S["FASTGROUNDMOUNT"][3] .."<br />"..
															"'"..GUPPET_S["SLOWFLYMOUNT"][1] 		.."'"..	GUPPET_S["USE"]	.."'".. GUPPET_S["SLOWFLYMOUNT"][2] 		.."' ".. GUPPET_S["SLOWFLYMOUNT"][3] .."<br />"..
															"'"..GUPPET_S["FASTFLYMOUNT"][1] 		.."'"..	GUPPET_S["USE"]	.."'".. GUPPET_S["FASTFLYMOUNT"][2] 		.."' ".. GUPPET_S["FASTFLYMOUNT"][3] .."<br />"..
															"'"..GUPPET_S["AQUATICMOUNT"][1] 		.."'"..	GUPPET_S["USE"]	.."'".. GUPPET_S["AQUATICMOUNT"][2] 		.."' ".. GUPPET_S["AQUATICMOUNT"][3] .."<br />"..
															"'"..GUPPET_S["AUTOMOUNT"][1] 		.."'"..	GUPPET_S["USE"]	.."'".. GUPPET_S["AUTOMOUNT"][2] 			.."' ".. GUPPET_S["AUTOMOUNT"][3] .."<br />"..
															"'"..GUPPET_S["AUTOGROUNDMOUNT"][1] 	.."'"..	GUPPET_S["USE"]	.."'".. GUPPET_S["AUTOGROUNDMOUNT"][2] 	.."' ".. GUPPET_S["AUTOGROUNDMOUNT"][3] .."<br />"..
															"'"..GUPPET_S["AUTOFLYMOUNT"][1] 		.."'"..	GUPPET_S["USE"]	.."'".. GUPPET_S["AUTOFLYMOUNT"][2] 		.."' ".. GUPPET_S["AUTOFLYMOUNT"][3] .."<br />"..
															"'"..GUPPET_S["CALLCOMPANION"][1] 	.."'"..	GUPPET_S["USE"]	.."'".. GUPPET_S["CALLCOMPANION"][2] 		.."' ".. GUPPET_S["CALLCOMPANION"][3] .."<br />"..
															"'"..GUPPET_S["OPTIONMENU"][1] 		.."'"..	GUPPET_S["USE"]	.."'".. GUPPET_S["OPTIONMENU"][2] 		.."' ".. GUPPET_S["OPTIONMENU"][3] .."<br />"..
														 
															" </p></body></html>"    ) ;
		GUPPET_INTERFACE_OPTIONFRAME.SlashCommands:SetFont('Fonts\\FRIZQT__.TTF', 10); 
		 
		----------------------------------------------------------------------------
		----------------------------------------------------------------------------
		-- AutoCompanion
		GUPPET_INTERFACE_OPTIONFRAME.AutoCallCompanionFrame = CreateFrame("FRAME", "GupPet_AutoCompanionFrame", GupPet_InterfaceOptionsFrameOptions , "GupPet_FieldTemplate");
 		GUPPET_INTERFACE_OPTIONFRAME.AutoCallCompanionFrame:SetWidth(200);
		GUPPET_INTERFACE_OPTIONFRAME.AutoCallCompanionFrame:SetHeight(185);	
		GUPPET_INTERFACE_OPTIONFRAME.AutoCallCompanionFrame:SetPoint("TOPLEFT", 260 , -30);
		getglobal("GupPet_AutoCompanionFrame" .. "SubTitle"):SetText("|cFFFC830E".. GUPPET_L["AUTOCALLCOMPANION"] ) ;	
		--
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion = CreateFrame("CheckButton", "GupPet_AutoCompanion"  , GUPPET_INTERFACE_OPTIONFRAME.AutoCallCompanionFrame, "OptionsSmallCheckButtonTemplate");
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion:SetPoint("TOPLEFT", 10, -10 );
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion:SetScript("OnClick", function (self, button, down) GUPPET_OPTIONS.AutoCompanion.Enabled=self:GetChecked(); GupPet_AutoCompanionSetEnable()    end);
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion:SetChecked(  GUPPET_OPTIONS.AutoCompanion.Enabled ); 
		getglobal("GupPet_AutoCompanion" .. "Text"):SetText( GUPPET_L["AUTOCALLCOMPANION_ENABLE"][1]  ) ;
		--
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_City = CreateFrame("CheckButton", "GupPet_AutoCompanionCity"  , GUPPET_INTERFACE_OPTIONFRAME.AutoCallCompanionFrame, "GupPet_CheckButtonTemplate");
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_City:SetPoint("TOPLEFT", 20, -32 );
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_City:SetScript("OnClick", function (self, button, down)   GUPPET_OPTIONS.AutoCompanion.City = self:GetChecked();     end);
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_City:SetChecked(  GUPPET_OPTIONS.AutoCompanion.City ); 
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_City:SetHitRectInsets( 0 , -50, 0 , 0);
		getglobal("GupPet_AutoCompanionCity" .. "Text"):SetText( GUPPET_L["AUTOCALLCOMPANION_CITY"][1]  ) ;
		--
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_Outside = CreateFrame("CheckButton", "GupPet_AutoCompanionOutside"  , GUPPET_INTERFACE_OPTIONFRAME.AutoCallCompanionFrame, "GupPet_CheckButtonTemplate");
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_Outside:SetPoint("TOPLEFT", 20, -47 );
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_Outside:SetScript("OnClick", function (self, button, down)   GUPPET_OPTIONS.AutoCompanion.Outside = self:GetChecked();    end);
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_Outside:SetChecked(  GUPPET_OPTIONS.AutoCompanion.Outside ); 
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_Outside:SetHitRectInsets( 0 , -50, 0 , 0);
		getglobal("GupPet_AutoCompanionOutside" .. "Text"):SetText( GUPPET_L["AUTOCALLCOMPANION_OUTSIDE"][1]  ) ;
		--
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_Arena = CreateFrame("CheckButton", "GupPet_AutoCompanionArena"  , GUPPET_INTERFACE_OPTIONFRAME.AutoCallCompanionFrame, "GupPet_CheckButtonTemplate");
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_Arena:SetPoint("TOPLEFT", 20, -62 );
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_Arena:SetScript("OnClick", function (self, button, down)   GUPPET_OPTIONS.AutoCompanion.Arena = self:GetChecked();     end);
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_Arena:SetChecked(  GUPPET_OPTIONS.AutoCompanion.Arena ); 
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_Arena:SetHitRectInsets( 0 , -50, 0 , 0);
		getglobal("GupPet_AutoCompanionArena" .. "Text"):SetText( GUPPET_L["AUTOCALLCOMPANION_ARENA"][1]  ) ;
		--
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_Instance = CreateFrame("CheckButton", "GupPet_AutoCompanionInstance"  , GUPPET_INTERFACE_OPTIONFRAME.AutoCallCompanionFrame, "GupPet_CheckButtonTemplate");
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_Instance:SetPoint("TOPLEFT", 20, -77 );
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_Instance:SetScript("OnClick", function (self, button, down)   GUPPET_OPTIONS.AutoCompanion.Instance = self:GetChecked();     end);
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_Instance:SetChecked(  GUPPET_OPTIONS.AutoCompanion.Instance ); 
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_Instance:SetHitRectInsets( 0 , -50, 0 , 0);
		getglobal("GupPet_AutoCompanionInstance" .. "Text"):SetText( GUPPET_L["AUTOCALLCOMPANION_INSTANCE"][1]  ) ;
		--
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_BattleGround = CreateFrame("CheckButton", "GupPet_AutoCompanionBattleGround"  , GUPPET_INTERFACE_OPTIONFRAME.AutoCallCompanionFrame, "GupPet_CheckButtonTemplate");
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_BattleGround:SetPoint("TOPLEFT", 20, -92 );
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_BattleGround:SetScript("OnClick", function (self, button, down)   GUPPET_OPTIONS.AutoCompanion.BattleGround = self:GetChecked();    end);
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_BattleGround:SetChecked(  GUPPET_OPTIONS.AutoCompanion.BattleGround ); 
		GUPPET_INTERFACE_OPTIONFRAME.AutoCompanion_BattleGround:SetHitRectInsets( 0 , -90, 0 , 0);
		getglobal("GupPet_AutoCompanionBattleGround" .. "Text"):SetText( GUPPET_L["AUTOCALLCOMPANION_BATTLEGROUND"][1]  ) ;
		-- 		
		GUPPET_INTERFACE_OPTIONFRAME.AutoCallDelay = CreateFrame('Slider', "GupPet_AutoCallDelay", GUPPET_INTERFACE_OPTIONFRAME.AutoCallCompanionFrame , 'OptionsSliderTemplate');
		GUPPET_INTERFACE_OPTIONFRAME.AutoCallDelay:SetPoint('TOP', 0, -125);
		GUPPET_INTERFACE_OPTIONFRAME.AutoCallDelay:SetOrientation('HORIZONTAL');
		GUPPET_INTERFACE_OPTIONFRAME.AutoCallDelay:SetWidth(140) ;
		GUPPET_INTERFACE_OPTIONFRAME.AutoCallDelay:SetHeight(17);
		GUPPET_INTERFACE_OPTIONFRAME.AutoCallDelay:SetMinMaxValues(2 , 10 );
		GUPPET_INTERFACE_OPTIONFRAME.AutoCallDelay:SetValueStep(0.1) ;
		GUPPET_INTERFACE_OPTIONFRAME.AutoCallDelay:SetValue( GUPPET_OPTIONS.AutoCompanion.Delay );
		GUPPET_INTERFACE_OPTIONFRAME.AutoCallDelay:SetScript("OnValueChanged", function (self)  GUPPET_OPTIONS.AutoCompanion.Delay = self:GetValue() ;       end);
		getglobal("GupPet_AutoCallDelay" .. "Text"):SetText(GUPPET_L["AUTOCALLCOMPANION_DELAY"][1]) ;
		getglobal("GupPet_AutoCallDelay" .. "Low"):SetText( "2") ;
		getglobal("GupPet_AutoCallDelay" .. "High"):SetText("10") ;
		GUPPET_INTERFACE_OPTIONFRAME.AutoCallDelay.tooltipText = GUPPET_L["AUTOCALLCOMPANION_DELAY"][2] ;
		
		--
		GUPPET_INTERFACE_OPTIONFRAME.DismissMounted = CreateFrame("CheckButton", "GupPet_DismissMounted"  , GUPPET_INTERFACE_OPTIONFRAME.AutoCallCompanionFrame, "OptionsSmallCheckButtonTemplate");
		GUPPET_INTERFACE_OPTIONFRAME.DismissMounted:SetPoint("TOPLEFT", 10, -155 );
		GUPPET_INTERFACE_OPTIONFRAME.DismissMounted:SetScript("OnClick", function (self, button, down) GUPPET_OPTIONS.AutoCompanion.DismissMounted=self:GetChecked();     end);
		GUPPET_INTERFACE_OPTIONFRAME.DismissMounted:SetChecked(  GUPPET_OPTIONS.AutoCompanion.DismissMounted ); 
		getglobal("GupPet_DismissMounted" .. "Text"):SetText( GUPPET_L["AUTOCALLCOMPANION_AUTODISMISSMOUNTED"][1]  ) ;
		--
		
		
		----------------------------------------------------------------------------
		----------------------------------------------------------------------------
		--Buttons
		
		 -- 
		 -- GUPPET_OPTIONS["IngameButton"] = {  
 --										Scale = 1 , Show = true , Lock = true , 
 --										MountButton = "Auto" , CompanionButton = true  }

		GUPPET_INTERFACE_OPTIONFRAME.IngameButtonFrame = CreateFrame("FRAME", "GupPet_IngameButtonFrame", GupPet_InterfaceOptionsFrameOptions , "GupPet_FieldTemplate");
 		GUPPET_INTERFACE_OPTIONFRAME.IngameButtonFrame:SetWidth(240);
		GUPPET_INTERFACE_OPTIONFRAME.IngameButtonFrame:SetHeight(135);	
		GUPPET_INTERFACE_OPTIONFRAME.IngameButtonFrame:SetPoint("TOPLEFT", 10 , -30);
		getglobal("GupPet_IngameButtonFrame" .. "SubTitle"):SetText("|cFFFC830E".. GUPPET_L["INGAMEBUTTONS"][1] )  ;	
 	
		GUPPET_INTERFACE_OPTIONFRAME.UIShow = CreateFrame("CheckButton", "GupPet_IngameButtonShow"  , GUPPET_INTERFACE_OPTIONFRAME.IngameButtonFrame, "OptionsSmallCheckButtonTemplate");
		GUPPET_INTERFACE_OPTIONFRAME.UIShow:SetPoint("TOPLEFT", 10, -10 );
		GUPPET_INTERFACE_OPTIONFRAME.UIShow:SetScript("OnClick", function (self, button, down)  GUPPET_OPTIONS["IngameButton"]["Show"]=self:GetChecked();  GupPet_Interface_IngameButtons();   end);
		GUPPET_INTERFACE_OPTIONFRAME.UIShow:SetChecked(  GUPPET_OPTIONS["IngameButton"]["Show"] ); 
		getglobal("GupPet_IngameButtonShow" .. "Text"):SetText( GUPPET_L["SHOW"][1]  ) ;
	
		GUPPET_INTERFACE_OPTIONFRAME.UIDrag = CreateFrame("CheckButton", "GupPet_IngameButtonDrag"  , GUPPET_INTERFACE_OPTIONFRAME.IngameButtonFrame, "GupPet_CheckButtonTemplate");
		GUPPET_INTERFACE_OPTIONFRAME.UIDrag:SetPoint("TOPLEFT", 20, -32 );
		GUPPET_INTERFACE_OPTIONFRAME.UIDrag:SetScript("OnClick", function (self, button, down)   GUPPET_OPTIONS["IngameButton"]["Lock"] = self:GetChecked() ;   if self:GetChecked() then GupPet_Interface_DragIngameButtons( "Hide" ) else GupPet_Interface_DragIngameButtons( "Show" ) end   ;  end);
		GUPPET_INTERFACE_OPTIONFRAME.UIDrag:SetChecked(  GUPPET_OPTIONS["IngameButton"]["Lock"] ); 
		GUPPET_INTERFACE_OPTIONFRAME.UIDrag:SetHitRectInsets( 0 , -50, 0 , 0);
		getglobal("GupPet_IngameButtonDrag" .. "Text"):SetText( GUPPET_L["LOCKED"][1]  ) ;
	
		GUPPET_INTERFACE_OPTIONFRAME.Restore = CreateFrame("Button", "GupPet_Restore", GUPPET_INTERFACE_OPTIONFRAME.IngameButtonFrame , "GupPet_ButtonTemplate");
		GUPPET_INTERFACE_OPTIONFRAME.Restore:SetScript("OnClick", function ()  GupPet_Interface_DragIngameButtons( "Reset" ); end) ;
		GUPPET_INTERFACE_OPTIONFRAME.Restore:SetWidth(60); 
		GUPPET_INTERFACE_OPTIONFRAME.Restore:SetHeight(15); 
		GUPPET_INTERFACE_OPTIONFRAME.Restore:SetPoint("TOPRIGHT",-10, -32);
		GUPPET_INTERFACE_OPTIONFRAME.Restore:SetText( GUPPET_L["RESTORE"][1] );
		GUPPET_INTERFACE_OPTIONFRAME.Restore.tooltipText = GUPPET_L["RESTORE"][2];
		GUPPET_INTERFACE_OPTIONFRAME.Restore:SetNormalFontObject( GupPet_FontText);
		GUPPET_INTERFACE_OPTIONFRAME.Restore:SetHighlightFontObject( GupPet_FontText);
		
		
		GUPPET_INTERFACE_OPTIONFRAME.ButtonMode = CreateFrame("CheckButton", "GupPet_ButtonMode"  , GUPPET_INTERFACE_OPTIONFRAME.IngameButtonFrame, "GupPet_CheckButtonTemplate");
		GUPPET_INTERFACE_OPTIONFRAME.ButtonMode:SetPoint("TOPLEFT", 20, -47 );
		GUPPET_INTERFACE_OPTIONFRAME.ButtonMode:SetScript("OnClick", function (self, button, down)  if self:GetChecked() then GUPPET_OPTIONS.IngameButton.MountButton = "Auto"   else GUPPET_OPTIONS.IngameButton.MountButton = "Hand"  end ; GupPet_Interface_IngameButtons(); end);
		GUPPET_INTERFACE_OPTIONFRAME.ButtonMode:SetChecked(  GUPPET_OPTIONS.IngameButton.MountButton == "Auto" and GUPPET_Z["SUPPORT"] == true  ); 
		getglobal("GupPet_ButtonMode" .. "Text"):SetText( GUPPET_L["BUTTONMODE"][1]  ) ;
		GUPPET_INTERFACE_OPTIONFRAME.ButtonMode.tooltipText = GUPPET_L["BUTTONMODE"][2] ;	
		if GUPPET_Z["SUPPORT"] == false then GUPPET_INTERFACE_OPTIONFRAME.ButtonMode.tooltipText = GUPPET_L["BUTTONMODE"][3]  end ;
		
 		
		GUPPET_INTERFACE_OPTIONFRAME.CompanionButtonShow = CreateFrame("CheckButton", "GupPet_CompanionButtonShow"  , GUPPET_INTERFACE_OPTIONFRAME.IngameButtonFrame, "GupPet_CheckButtonTemplate");
		GUPPET_INTERFACE_OPTIONFRAME.CompanionButtonShow:SetPoint("TOPLEFT", 20, -62 );
		GUPPET_INTERFACE_OPTIONFRAME.CompanionButtonShow:SetScript("OnClick", function (self, button, down)   GUPPET_OPTIONS.IngameButton.CompanionButton = self:GetChecked() ;  GupPet_Interface_IngameButtons();  end);
		GUPPET_INTERFACE_OPTIONFRAME.CompanionButtonShow:SetChecked( GUPPET_OPTIONS["IngameButton"]["CompanionButton"] ); 
		getglobal("GupPet_CompanionButtonShow" .. "Text"):SetText( GUPPET_L["COMPANIONBUTTONSHOW"][1]  ) ;

		GUPPET_INTERFACE_OPTIONFRAME.Scale = CreateFrame('Slider', "GupPet_Scale", GUPPET_INTERFACE_OPTIONFRAME.IngameButtonFrame , 'OptionsSliderTemplate');
		GUPPET_INTERFACE_OPTIONFRAME.Scale:SetPoint('TOP', 0, -100); 
		GUPPET_INTERFACE_OPTIONFRAME.Scale:SetOrientation('HORIZONTAL');
		GUPPET_INTERFACE_OPTIONFRAME.Scale:SetWidth(160) ;
		GUPPET_INTERFACE_OPTIONFRAME.Scale:SetHeight(17);
		GUPPET_INTERFACE_OPTIONFRAME.Scale:SetMinMaxValues(0.2 , 2.5 );
		GUPPET_INTERFACE_OPTIONFRAME.Scale:SetValueStep(0.05) ;
		GUPPET_INTERFACE_OPTIONFRAME.Scale:SetValue( GUPPET_OPTIONS["IngameButton"]["Scale"] );
		GUPPET_INTERFACE_OPTIONFRAME.Scale:SetScript("OnValueChanged", function (self)   GUPPET_OPTIONS["IngameButton"]["Scale"] = self:GetValue() ;  GUPPET_INTERFACE_INGAMEBUTTONS.Frame:SetScale( GUPPET_OPTIONS.IngameButton.Scale );      end);
		getglobal("GupPet_Scale" .. "Text"):SetText(GUPPET_L["SCALE"][1]) ;
		getglobal("GupPet_Scale" .. "Low"):SetText(GUPPET_L["SCALE"][2]) ;
		getglobal("GupPet_Scale" .. "High"):SetText(GUPPET_L["SCALE"][3]) ;
		
		----------------------------------------------------------------------------
		----------------------------------------------------------------------------
		-- Extra
		GUPPET_INTERFACE_OPTIONFRAME.ExtraFrame = CreateFrame("FRAME", "GupPet_ExtraFrame", GupPet_InterfaceOptionsFrameOptions , "GupPet_FieldTemplate");
 		GUPPET_INTERFACE_OPTIONFRAME.ExtraFrame:SetWidth(200);
		GUPPET_INTERFACE_OPTIONFRAME.ExtraFrame:SetHeight(70);	
		GUPPET_INTERFACE_OPTIONFRAME.ExtraFrame:SetPoint("TOPRIGHT", -10 , -30);
		getglobal("GupPet_ExtraFrame" .. "SubTitle"):SetText("|cFFFC830E".. GUPPET_L["EXTRA"][1]) ;			 
				 
		GUPPET_INTERFACE_OPTIONFRAME.AutoDismount = CreateFrame("CheckButton", "GupPet_AutoDismount"  , GUPPET_INTERFACE_OPTIONFRAME.ExtraFrame, "OptionsSmallCheckButtonTemplate");
		GUPPET_INTERFACE_OPTIONFRAME.AutoDismount:SetPoint("TOPLEFT", 10, -10 );
		GUPPET_INTERFACE_OPTIONFRAME.AutoDismount:SetScript("OnClick", function (self, button, down)    GupPet_AutoDismount(  self:GetChecked() )  end);
		GUPPET_INTERFACE_OPTIONFRAME.AutoDismount:SetChecked(  GUPPET_OPTIONS["AutoDismount"] ); 
		getglobal("GupPet_AutoDismount" .. "Text"):SetText( GUPPET_L["AUTODISMOUNT"][1]  ) ;
		GUPPET_INTERFACE_OPTIONFRAME.AutoDismount.tooltipText = GUPPET_L["AUTODISMOUNT"][2] ;	
	
		GUPPET_INTERFACE_OPTIONFRAME.ExpertMode = CreateFrame("CheckButton", "GupPet_ExpertMode"  , GUPPET_INTERFACE_OPTIONFRAME.ExtraFrame, "OptionsSmallCheckButtonTemplate");
		GUPPET_INTERFACE_OPTIONFRAME.ExpertMode:SetPoint("TOPLEFT", 10, -30 );
		GUPPET_INTERFACE_OPTIONFRAME.ExpertMode:SetScript("OnClick", function (self, button, down)  StaticPopup_Show ("GupPet_Interface_ChangeMode");   end);
		GUPPET_INTERFACE_OPTIONFRAME.ExpertMode:SetChecked(  GUPPET_OPTIONS.Mode == "Expert" ); 
		getglobal("GupPet_ExpertMode" .. "Text"):SetText( GUPPET_L["EXPERTMODE"][1]  ) ;
		GUPPET_INTERFACE_OPTIONFRAME.ExpertMode.tooltipText = GUPPET_L["EXPERTMODE"][2] ;	

		
		----------------------------------------------------------------------------
		----------------------------------------------------------------------------
		-- PREVIEW FRAME
		
		GUPPET_INTERFACE_OPTIONFRAME.PreviewFrame = CreateFrame("FRAME", "GupPet_PreviewFrame", GupPet_InterfaceOptionsFrameOptions , "GupPet_FieldTemplate");
		GUPPET_INTERFACE_OPTIONFRAME.PreviewFrame:SetWidth(200);
		GUPPET_INTERFACE_OPTIONFRAME.PreviewFrame:SetHeight(92);	
		GUPPET_INTERFACE_OPTIONFRAME.PreviewFrame:SetPoint("TOPLEFT", 10 , -190);
		getglobal("GupPet_PreviewFrame" .. "SubTitle"):SetText("|cFFFC830E".. GUPPET_L["PREVIEWFRAME"][1]) ;	
		
		GUPPET_INTERFACE_OPTIONFRAME.PreviewFrameSpeed = CreateFrame('Slider', "GupPet_PreviewFrameSpeed", GUPPET_INTERFACE_OPTIONFRAME.PreviewFrame , 'OptionsSliderTemplate');
		GUPPET_INTERFACE_OPTIONFRAME.PreviewFrameSpeed:SetPoint('TOP', 0, -20);
		GUPPET_INTERFACE_OPTIONFRAME.PreviewFrameSpeed:SetOrientation('HORIZONTAL');
		GUPPET_INTERFACE_OPTIONFRAME.PreviewFrameSpeed:SetWidth(160) ;
		GUPPET_INTERFACE_OPTIONFRAME.PreviewFrameSpeed:SetHeight(17);
		GUPPET_INTERFACE_OPTIONFRAME.PreviewFrameSpeed:SetMinMaxValues( -1 , 1 );
		GUPPET_INTERFACE_OPTIONFRAME.PreviewFrameSpeed:SetValueStep(0.5) ;
		GUPPET_INTERFACE_OPTIONFRAME.PreviewFrameSpeed:SetValue( GUPPET_OPTIONS.PreviewFrameSpeed );
		GUPPET_INTERFACE_OPTIONFRAME.PreviewFrameSpeed:SetScript("OnValueChanged", function (self)   GUPPET_OPTIONS.PreviewFrameSpeed = self:GetValue() ;        end);
		getglobal("GupPet_PreviewFrameSpeed" .. "Text"):SetText(GUPPET_L["PREVIEWFRAMESPEED"][1]) ;
		getglobal("GupPet_PreviewFrameSpeed" .. "Low"):SetText(GUPPET_L["PREVIEWFRAMESPEED"][2]) ;
		getglobal("GupPet_PreviewFrameSpeed" .. "High"):SetText(GUPPET_L["PREVIEWFRAMESPEED"][3]) ;
		
		
		GUPPET_INTERFACE_OPTIONFRAME.PreviewFrameStartPos = CreateFrame('Slider', "GupPet_PreviewFrameStartPos", GUPPET_INTERFACE_OPTIONFRAME.PreviewFrame , 'OptionsSliderTemplate');
		GUPPET_INTERFACE_OPTIONFRAME.PreviewFrameStartPos:SetPoint('TOP', 0, -60);
		GUPPET_INTERFACE_OPTIONFRAME.PreviewFrameStartPos:SetOrientation('HORIZONTAL');
		GUPPET_INTERFACE_OPTIONFRAME.PreviewFrameStartPos:SetWidth(160) ;
		GUPPET_INTERFACE_OPTIONFRAME.PreviewFrameStartPos:SetHeight(17);
		GUPPET_INTERFACE_OPTIONFRAME.PreviewFrameStartPos:SetMinMaxValues( -3.14 , 3.14 );
		GUPPET_INTERFACE_OPTIONFRAME.PreviewFrameStartPos:SetValueStep( 0.1 ) ;
		GUPPET_INTERFACE_OPTIONFRAME.PreviewFrameStartPos:SetValue( GUPPET_OPTIONS.PreviewFrameStartPos );
		GUPPET_INTERFACE_OPTIONFRAME.PreviewFrameStartPos:SetScript("OnValueChanged", function (self)   GUPPET_OPTIONS.PreviewFrameStartPos = self:GetValue() ;        end);
		getglobal("GupPet_PreviewFrameStartPos" .. "Text"):SetText(GUPPET_L["PREVIEWFRAMESTARTPOS"][1]) ;
		getglobal("GupPet_PreviewFrameStartPos" .. "Low"):SetText(GUPPET_L["PREVIEWFRAMESTARTPOS"][2]) ;
		getglobal("GupPet_PreviewFrameStartPos" .. "High"):SetText(GUPPET_L["PREVIEWFRAMESTARTPOS"][3]) ;		
		
		
		----------------------------------------------------------------------------
		----------------------------------------------------------------------------
		-- CLASS
		if GUPPET_TEMPCLASSDATA.Type == "DRUID" or GUPPET_TEMPCLASSDATA.Type == "SHAMAN" or GUPPET_TEMPCLASSDATA.Type == "MAGE"  then

			GUPPET_INTERFACE_OPTIONFRAME.ClassFrame = CreateFrame("FRAME", "GupPet_ClassFrame", GupPet_InterfaceOptionsFrameOptions , "GupPet_FieldTemplate");
			GUPPET_INTERFACE_OPTIONFRAME.ClassFrame:SetWidth(200);
			GUPPET_INTERFACE_OPTIONFRAME.ClassFrame:SetHeight(70);	
			GUPPET_INTERFACE_OPTIONFRAME.ClassFrame:SetPoint("TOPRIGHT", -10 , -140);
			getglobal("GupPet_ClassFrame" .. "SubTitle"):SetText("|cFFFC830E".. GUPPET_L["CLASS"][1]) ;	
		
		end
		
		if GUPPET_TEMPCLASSDATA.Type == "DRUID" then
			-- Enable / Disable --> Travel / SlowFly / FastFly / Aquatic
			GUPPET_INTERFACE_OPTIONFRAME.ClassFrame:SetHeight(70);
	 
	 	 	GUPPET_INTERFACE_OPTIONFRAME.DRUID_Fly = CreateFrame("CheckButton", "GupPet_DRUID_Fly"  , GUPPET_INTERFACE_OPTIONFRAME.ClassFrame , "GupPet_CheckButtonTemplate");
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Fly:SetPoint("TOPLEFT", 10, -10 );
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Fly:SetScript("OnClick", function (self, button, down)   GUPPET_OPTIONS["Class"]["FlyForm"] = self:GetChecked()  end);
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Fly:SetChecked(  GUPPET_OPTIONS["Class"]["FlyForm"]  ); 
			getglobal("GupPet_DRUID_Fly" .. "Text"):SetText( GUPPET_L["DRUID_Fly"][1]  ) ;
			
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Aquatic = CreateFrame("CheckButton", "GupPet_DRUID_Aquatic"  , GUPPET_INTERFACE_OPTIONFRAME.ClassFrame , "GupPet_CheckButtonTemplate");
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Aquatic:SetPoint("TOPLEFT", 10, -25 );
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Aquatic:SetScript("OnClick", function (self, button, down)   GUPPET_OPTIONS["Class"]["AquaticForm"] = self:GetChecked()  end);
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Aquatic:SetChecked(  GUPPET_OPTIONS["Class"]["AquaticForm"]  ); 
			getglobal("GupPet_DRUID_Aquatic" .. "Text"):SetText( GUPPET_L["DRUID_Aquatic"][1]  ) ;	
			
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Travel = CreateFrame("CheckButton", "GupPet_DRUID_Travel"  , GUPPET_INTERFACE_OPTIONFRAME.ClassFrame , "GupPet_CheckButtonTemplate");
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Travel:SetPoint("TOPLEFT", 10, -40 );
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Travel:SetScript("OnClick", function (self, button, down)   GUPPET_OPTIONS["Class"]["TravelOnFormWalking"] = self:GetChecked()  end);
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Travel:SetChecked(  GUPPET_OPTIONS["Class"]["TravelOnFormWalking"]  ); 
			getglobal("GupPet_DRUID_Travel" .. "Text"):SetText( GUPPET_L["DRUID_Travel"][1]  ) ;	
			
			
			
		elseif GUPPET_TEMPCLASSDATA.Type == "SHAMAN" then
			-- Enable / Disable --> Ghost enable on Moving 
			GUPPET_INTERFACE_OPTIONFRAME.ClassFrame:SetHeight(40);
			
	 		GUPPET_INTERFACE_OPTIONFRAME.SHAMAN_Ghost = CreateFrame("CheckButton", "GupPet_SHAMAN_Ghost"  , GUPPET_INTERFACE_OPTIONFRAME.ClassFrame , "GupPet_CheckButtonTemplate");
			GUPPET_INTERFACE_OPTIONFRAME.SHAMAN_Ghost:SetPoint("TOPLEFT", 10, -10 );
			GUPPET_INTERFACE_OPTIONFRAME.SHAMAN_Ghost:SetScript("OnClick", function (self, button, down)   GUPPET_OPTIONS["Class"]["GhostWolfOnWalking"] = self:GetChecked()  end);
			GUPPET_INTERFACE_OPTIONFRAME.SHAMAN_Ghost:SetChecked(  GUPPET_OPTIONS["Class"]["GhostWolfOnWalking"]  ); 
			getglobal("GupPet_SHAMAN_Ghost" .. "Text"):SetText( GUPPET_L["SHAMAN_Ghost"][1]  ) ;
		
		elseif GUPPET_TEMPCLASSDATA.Type == "MAGE" then
			-- Enable / Disable --> Slowfall on falling  
			GUPPET_INTERFACE_OPTIONFRAME.ClassFrame:SetHeight(40);
			
	 		GUPPET_INTERFACE_OPTIONFRAME.MAGE_SlowFall = CreateFrame("CheckButton", "GupPet_MAGE_SlowFall"  , GUPPET_INTERFACE_OPTIONFRAME.ClassFrame , "GupPet_CheckButtonTemplate");
			GUPPET_INTERFACE_OPTIONFRAME.MAGE_SlowFall:SetPoint("TOPLEFT", 10, -10 );
			GUPPET_INTERFACE_OPTIONFRAME.MAGE_SlowFall:SetScript("OnClick", function (self, button, down)   GUPPET_OPTIONS["Class"]["SlowFallOnFalling"] = self:GetChecked()  end);
			GUPPET_INTERFACE_OPTIONFRAME.MAGE_SlowFall:SetChecked(  GUPPET_OPTIONS["Class"]["SlowFallOnFalling"]  ); 
			getglobal("GupPet_MAGE_SlowFall" .. "Text"):SetText( GUPPET_L["MAGE_SlowFall"][1]  ) ;
		end
		
		
		
		
		
		
		
	end
end


-- Update the locations field
function GupPet_Interface_UpdateLocationFrame()

	local i = 0 ;
	
--	for SavedLocation , ZoneType in GupPet_Interface_SortLocations(GUPPET_SAVEDLOCATIONS) do
		for SavedLocation , ZoneType in GupPet_Interface_SortLocations(GUPPET_SAVEDLOCATIONS) do
		i = i+1 ;

		if i > GUPPET_INTERFACE_LOCATIONFRAME.Total then
			GUPPET_INTERFACE_LOCATIONFRAME[ i ] = CreateFrame("Button", "GupPet_InterfaceOptionsFrameMountsCompanionsLocations"..i  ,  GupPet_InterfaceOptionsFrameMountsCompanionsLocationsData , "GupPet_OptionsListButtonTemplate");
			GUPPET_INTERFACE_LOCATIONFRAME[ i ]:SetPoint("TOPLEFT", 0, 15 - (i*20));
		end
		getglobal("GupPet_InterfaceOptionsFrameMountsCompanionsLocations"..i):Show();		
		getglobal("GupPet_InterfaceOptionsFrameMountsCompanionsLocations"..i.."Text"):SetText( SavedLocation );
		getglobal("GupPet_InterfaceOptionsFrameMountsCompanionsLocations"..i).Location = SavedLocation ;

		if  ZoneType <= 9 then 
			getglobal("GupPet_InterfaceOptionsFrameMountsCompanionsLocations"..i.."Text"):SetTextColor(1,1,1) ;
		elseif  ZoneType <= 19 then 
			getglobal("GupPet_InterfaceOptionsFrameMountsCompanionsLocations"..i.."Text"):SetTextColor(0,0.5,0) ;
		elseif  ZoneType <= 29 then 
			getglobal("GupPet_InterfaceOptionsFrameMountsCompanionsLocations"..i.."Text"):SetTextColor(1,1,0) ;
		elseif  ZoneType <= 39 then 
			getglobal("GupPet_InterfaceOptionsFrameMountsCompanionsLocations"..i.."Text"):SetTextColor(1,0,0) ;	
		else
			getglobal("GupPet_InterfaceOptionsFrameMountsCompanionsLocations"..i.."Text"):SetTextColor(0,0.5,1) ;
		end
		
		if ZoneType == 0 or ZoneType == 10 or ZoneType == 20 or ZoneType == 30 or ZoneType == 40 then
			getglobal("GupPet_InterfaceOptionsFrameMountsCompanionsLocations"..i.."Text"):SetPoint("LEFT", 5, 0);
		else
			getglobal("GupPet_InterfaceOptionsFrameMountsCompanionsLocations"..i.."Text"):SetPoint("LEFT", 20, 0);
		end
	end

	-- Hide unneedid buttons
	for q = 1 ,GUPPET_INTERFACE_LOCATIONFRAME.Total-i do
		z = q + i ;
		getglobal("GupPet_InterfaceOptionsFrameMountsCompanionsLocations"..z):Hide() ;
	end
	
	GupPet_Interface_ScrollFrame_Update( getglobal("GupPet_InterfaceOptionsFrameMountsCompanionsLocations" .. "Container") , i ,20 ,20 , 190-10);
	
	-- Set First Active After some changes.. 
	GupPet_Interface_RemoveLocationSelected()
	GupPet_Interface_SetLocationSelected( getglobal("GupPet_InterfaceOptionsFrameMountsCompanionsLocations1") ) ;
	GupPet_Interface_UpdateMountFrame( getglobal("GupPet_InterfaceOptionsFrameMountsCompanionsLocations1").Location ) ;
	
	-- Update the number of created buttons ( If more are created save that )
	if GUPPET_INTERFACE_LOCATIONFRAME.Total < i then
		GUPPET_INTERFACE_LOCATIONFRAME.Total =  i ;
	end
	
end


function GupPet_Interface_GetLocationSelected()
	return getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location ;
end

function GupPet_Interface_RemoveLocationSelected()

	if not( GUPPET_INTERFACE_LOCATIONFRAME.Selected == nil) then
		getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected):UnlockHighlight();
	end
end

function GupPet_Interface_SetLocationSelected( button )
	button:LockHighlight()
	GUPPET_INTERFACE_LOCATIONFRAME.Selected = button:GetName();
end



-- Update the field from mounts
function GupPet_Interface_UpdateMountFrame( Location )

	
	if GUPPET_INTERFACE_MAINFRAME.Init == 0 then
		GUPPET_INTERFACE_MAINFRAME.Init = 1 ;
		
		-- Aquatic
		GUPPET_INTERFACE_MAINFRAME.Aquatic.Frame = CreateFrame("FRAME", "Aquatic", GupPet_InterfaceOptionsFrameMountsCompanionsMainAquatic , "GupPet_DataFieldTemplate");
 		GUPPET_INTERFACE_MAINFRAME.Aquatic.Frame:SetWidth(450); --190
		GUPPET_INTERFACE_MAINFRAME.Aquatic.Frame:SetHeight(360);	
		GUPPET_INTERFACE_MAINFRAME.Aquatic.Frame:SetPoint("TOPLEFT", 0 , -30);
			
		getglobal("Aquatic" .. "SubTitle"):SetText("|cFFFC830E ".. GUPPET_L["AQUATICMOUNT"][1]   ) ;	
		getglobal("Aquatic" .. "Container"):SetWidth(418);
		getglobal("Aquatic" .. "Container"):SetHeight(350);
		getglobal("Aquatic" .. "Enable" ):SetScript("OnClick", function () GupPet_SetWeight( "Aquatic" , 0 , 1001 , getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location ) ; GupPet_Interface_UpdateMountFrame( getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location )  end) ;
		getglobal("Aquatic" .. "Disable"):SetScript("OnClick", function () GupPet_SetWeight( "Aquatic" , 0 , 1000 , getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location ) ; GupPet_Interface_UpdateMountFrame( getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location )  end) ;			
	
		-- GROUND
		GUPPET_INTERFACE_MAINFRAME.SlowGround.Frame = CreateFrame("FRAME", "SlowGround", GupPet_InterfaceOptionsFrameMountsCompanionsMainGround , "GupPet_DataFieldTemplate");
 		GUPPET_INTERFACE_MAINFRAME.SlowGround.Frame:SetWidth(225); --190
		GUPPET_INTERFACE_MAINFRAME.SlowGround.Frame:SetHeight(360);	
		GUPPET_INTERFACE_MAINFRAME.SlowGround.Frame:SetPoint("TOPLEFT", 0 , -30);
			
		getglobal("SlowGround" .. "SubTitle"):SetText("|cFFFC830E ".. GUPPET_L["SLOWGROUNDMOUNT"][1] .." ".. GUPPET_L["SLOWGROUNDMOUNT"][2]) ;	
		getglobal("SlowGround" .. "Container"):SetWidth(193);
		getglobal("SlowGround" .. "Container"):SetHeight(350);
		getglobal("SlowGround" .. "Enable" ):SetScript("OnClick", function () GupPet_SetWeight( "SlowGround" , 0 , 1001 , getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location ) ; GupPet_Interface_UpdateMountFrame( getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location )  end) ;
		getglobal("SlowGround" .. "Disable"):SetScript("OnClick", function () GupPet_SetWeight( "SlowGround" , 0 , 1000 , getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location ) ; GupPet_Interface_UpdateMountFrame( getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location )  end) ;			
			
		GUPPET_INTERFACE_MAINFRAME.FastGround.Frame = CreateFrame("FRAME", "FastGround", GupPet_InterfaceOptionsFrameMountsCompanionsMainGround , "GupPet_DataFieldTemplate");
 		GUPPET_INTERFACE_MAINFRAME.FastGround.Frame:SetWidth(225); --190
		GUPPET_INTERFACE_MAINFRAME.FastGround.Frame:SetHeight(360);	
		GUPPET_INTERFACE_MAINFRAME.FastGround.Frame:SetPoint("TOPRIGHT", 0 , -30);
			
		getglobal("FastGround" .. "SubTitle"):SetText("|cFFFC830E ".. GUPPET_L["FASTGROUNDMOUNT"][1] .." ".. GUPPET_L["FASTGROUNDMOUNT"][2] ) ;	
		getglobal("FastGround" .. "Container"):SetWidth(193);
		getglobal("FastGround" .. "Container"):SetHeight(350);
		getglobal("FastGround" .. "Enable" ):SetScript("OnClick", function () GupPet_SetWeight( "FastGround" , 0 , 1001 , getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location ) ; GupPet_Interface_UpdateMountFrame( getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location )  end) ;
		getglobal("FastGround" .. "Disable"):SetScript("OnClick", function () GupPet_SetWeight( "FastGround" , 0 , 1000 , getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location ) ; GupPet_Interface_UpdateMountFrame( getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location )  end) ;			
	
	
		--FLY
		GUPPET_INTERFACE_MAINFRAME.SlowFly.Frame = CreateFrame("FRAME", "SlowFly", GupPet_InterfaceOptionsFrameMountsCompanionsMainFly , "GupPet_DataFieldTemplate");
 		GUPPET_INTERFACE_MAINFRAME.SlowFly.Frame:SetWidth(225); --190
		GUPPET_INTERFACE_MAINFRAME.SlowFly.Frame:SetHeight(360);	
		GUPPET_INTERFACE_MAINFRAME.SlowFly.Frame:SetPoint("TOPLEFT", 0 , -30);
			
		getglobal("SlowFly" .. "SubTitle"):SetText("|cFFFC830E ".. GUPPET_L["SLOWFLYMOUNT"][1] .." ".. GUPPET_L["SLOWFLYMOUNT"][2]) ;	
		getglobal("SlowFly" .. "Container"):SetWidth(193);
		getglobal("SlowFly" .. "Container"):SetHeight(350);
		getglobal("SlowFly" .. "Enable" ):SetScript("OnClick", function () GupPet_SetWeight( "SlowFly" , 0 , 1001 , getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location ) ; GupPet_Interface_UpdateMountFrame( getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location )  end) ;
		getglobal("SlowFly" .. "Disable"):SetScript("OnClick", function () GupPet_SetWeight( "SlowFly" , 0 , 1000 , getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location ) ; GupPet_Interface_UpdateMountFrame( getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location )  end) ;			

	
		GUPPET_INTERFACE_MAINFRAME.FastFly.Frame = CreateFrame("FRAME", "FastFly", GupPet_InterfaceOptionsFrameMountsCompanionsMainFly , "GupPet_DataFieldTemplate");
 		GUPPET_INTERFACE_MAINFRAME.FastFly.Frame:SetWidth(225); --190
		GUPPET_INTERFACE_MAINFRAME.FastFly.Frame:SetHeight(360);	
		GUPPET_INTERFACE_MAINFRAME.FastFly.Frame:SetPoint("TOPRIGHT", 0 , -30);
			
		getglobal("FastFly" .. "SubTitle"):SetText("|cFFFC830E ".. GUPPET_L["FASTFLYMOUNT"][1] .." ".. GUPPET_L["FASTFLYMOUNT"][2]) ;	
		getglobal("FastFly" .. "Container"):SetWidth(193);
		getglobal("FastFly" .. "Container"):SetHeight(350);
		getglobal("FastFly" .. "Enable" ):SetScript("OnClick", function () GupPet_SetWeight( "FastFly" , 0 , 1001 , getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location ) ; GupPet_Interface_UpdateMountFrame( getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location )  end) ;
		getglobal("FastFly" .. "Disable"):SetScript("OnClick", function () GupPet_SetWeight( "FastFly" , 0 , 1000 , getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location ) ; GupPet_Interface_UpdateMountFrame( getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location )  end) ;			

	
		-- Companion
		GUPPET_INTERFACE_MAINFRAME.Companion.Frame = CreateFrame("FRAME", "Companion", GupPet_InterfaceOptionsFrameMountsCompanionsMainCompanion , "GupPet_DataFieldTemplate");
 		GUPPET_INTERFACE_MAINFRAME.Companion.Frame:SetWidth(450); --190
		GUPPET_INTERFACE_MAINFRAME.Companion.Frame:SetHeight(360);	
		GUPPET_INTERFACE_MAINFRAME.Companion.Frame:SetPoint("TOPLEFT", 0 , -30);
			
		getglobal("Companion" .. "SubTitle"):SetText("|cFFFC830E ".. GUPPET_L["COMPANION"][1] .." ".. GUPPET_L["COMPANION"][2]) ;	
		getglobal("Companion" .. "Container"):SetWidth(418);
		getglobal("Companion" .. "Container"):SetHeight(350);
		getglobal("Companion" .. "Enable" ):SetScript("OnClick", function () GupPet_SetWeight( "Companion" , 0 , 1001 , getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location ) ; GupPet_Interface_UpdateMountFrame( getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location )  end) ;
		getglobal("Companion" .. "Disable"):SetScript("OnClick", function () GupPet_SetWeight( "Companion" , 0 , 1000 , getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location ) ; GupPet_Interface_UpdateMountFrame( getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location )  end) ;			
 
	end
	
	---------------------------------------------------
	GUPPET_INTERFACE_MAINFRAME.Aquatic = GupPet_Interface_UpdateLocalFrame( GUPPET_INTERFACE_MAINFRAME.Aquatic ,  "Aquatic" ) ;
	GupPet_Interface_ScrollFrame_Update( getglobal("Aquatic" .. "Container") , GUPPET_INTERFACE_MAINFRAME.Aquatic.Temp ,23 ,15 , 215);
	---------------------------------------------------
	GUPPET_INTERFACE_MAINFRAME.SlowGround = GupPet_Interface_UpdateLocalFrame( GUPPET_INTERFACE_MAINFRAME.SlowGround ,  "SlowGround" ) ;
	GupPet_Interface_ScrollFrame_Update( getglobal("SlowGround" .. "Container") , GUPPET_INTERFACE_MAINFRAME.SlowGround.Temp ,23 ,15 , 215);	
	---------------------------------------------------
	GUPPET_INTERFACE_MAINFRAME.FastGround = GupPet_Interface_UpdateLocalFrame( GUPPET_INTERFACE_MAINFRAME.FastGround ,  "FastGround" ) ;
	GupPet_Interface_ScrollFrame_Update( getglobal("FastGround" .. "Container") , GUPPET_INTERFACE_MAINFRAME.FastGround.Temp ,23 ,15 , 215);		
	---------------------------------------------------
	GUPPET_INTERFACE_MAINFRAME.SlowFly = GupPet_Interface_UpdateLocalFrame( GUPPET_INTERFACE_MAINFRAME.SlowFly ,  "SlowFly" ) ;
	GupPet_Interface_ScrollFrame_Update( getglobal("SlowFly" .. "Container") , GUPPET_INTERFACE_MAINFRAME.SlowFly.Temp ,23 ,15 , 215);	
	---------------------------------------------------
	GUPPET_INTERFACE_MAINFRAME.FastFly = GupPet_Interface_UpdateLocalFrame( GUPPET_INTERFACE_MAINFRAME.FastFly ,  "FastFly" ) ;
	GupPet_Interface_ScrollFrame_Update( getglobal("FastFly" .. "Container") , GUPPET_INTERFACE_MAINFRAME.FastFly.Temp ,23 ,15 , 215);
	---------------------------------------------------
	
	GUPPET_INTERFACE_MAINFRAME.Companion = GupPet_Interface_UpdateLocalDuelFrame( GUPPET_INTERFACE_MAINFRAME.Companion ,  "Companion" ) ;
	GupPet_Interface_ScrollFrame_Update( getglobal("Companion" .. "Container") , math.ceil(GUPPET_INTERFACE_MAINFRAME.Companion.Temp/2) ,23 ,15 , 440);
end


function GupPet_Interface_UpdateLocalFrame( Data ,  MountType )

  local t_i = 0 ;

	for i = 1 , GUPPET_SAVEDDATA[ MountType ]["Total"] do

		if GUPPET_OPTIONS.Mode == "Expert" then
			if ( Data.Temp < i ) then

				Data[i] = CreateFrame('Slider', MountType..i , getglobal( MountType .. "Data") , 'GupPet_SliderTemplate');
				Data[i]:SetPoint('TOPLEFT', 10, 15-(i*15));
				Data[i]:SetMinMaxValues(0 , 10);
				Data[i]:SetValueStep( 1) ;
			end
				
			getglobal(MountType..i ):SetValue( GUPPET_SAVEDDATA[MountType][ i ]["Weight"][ getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location ] );
			getglobal(MountType..i ):SetScript("OnValueChanged", function (self)   GupPet_SetWeight( MountType , i , self:GetValue() , getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location ) ;       end);
		
		else 
			if ( Data.Temp < i ) then

				Data[i] = CreateFrame("CheckButton", MountType..i , getglobal( MountType .. "Data") , "GupPet_CheckButtonTemplate");
				Data[i]:SetPoint('TOPLEFT', 10, 15-(i*15));
			end

			getglobal(MountType..i ):SetChecked( GUPPET_SAVEDDATA[MountType][ i ]["Weight"][ getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location ] );
		--	getglobal(MountType..i ):SetScript("OnClick", function (self)   GupPet_SetWeight( MountType , i , self:GetChecked() , getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location )   ;       end);
			getglobal(MountType..i ):SetScript("OnClick", function (self)   
					if ( IsModifiedClick() ) then   
			
						self:SetChecked( not self:GetChecked() ) ;
			
						if ( IsModifiedClick("CHATLINK") ) then
							if ( MacroFrame and MacroFrame:IsShown() ) then
								local spellName = GetSpellInfo( GUPPET_SAVEDDATA[MountType][ i ]["Id"] );
								ChatEdit_InsertLink(spellName);
							else
								local spellLink = GetSpellLink( GUPPET_SAVEDDATA[MountType][ i ]["Id"] );
								ChatEdit_InsertLink(spellLink);
							end
						end
					else   
						GupPet_SetWeight( MountType , i , self:GetChecked() , getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location )   ;       
					end
				end);
		end
		
		getglobal(MountType..i .. "Text"):SetText( GUPPET_SAVEDDATA[MountType][ i ]["Name"]  ) ;
		getglobal(MountType..i ):SetScript("OnEnter", function(self, button, down)	GupPet_PreviewModel:SetCreature( GUPPET_SAVEDDATA[MountType][ i ]["CreatureID"]  )	GupPet_Preview:Show() end);
		getglobal(MountType..i ):SetScript("OnLeave", function() GupPet_Preview:Hide()	end);	
	
		t_i = i ;
	end

	Data.Temp =  t_i ;


return Data

end


function GupPet_Interface_UpdateLocalDuelFrame( Data ,  MountType )

  local t_i = 0 ;

	for i = 1 , math.ceil(GUPPET_SAVEDDATA[ MountType ]["Total"]/2) do

		if GUPPET_OPTIONS.Mode == "Expert" then
			if ( Data.Temp- math.ceil(GUPPET_SAVEDDATA[ MountType ]["Total"]/2) < i ) then

				Data[i] = CreateFrame('Slider', MountType..i , getglobal( MountType .. "Data") , 'GupPet_SliderTemplate');
				
				Data[i]:SetMinMaxValues(0 , 10);
				Data[i]:SetValueStep( 1) ;
			end
				
			getglobal(MountType..i ):SetValue( GUPPET_SAVEDDATA[MountType][ i ]["Weight"][ getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location ] );
			getglobal(MountType..i ):SetScript("OnValueChanged", function (self)   GupPet_SetWeight( MountType , i , self:GetValue() , getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location ) ;       end);
		
		else 
			if ( Data.Temp- math.ceil(GUPPET_SAVEDDATA[ MountType ]["Total"]/2) < i ) then

				Data[i] = CreateFrame("CheckButton", MountType..i , getglobal( MountType .. "Data") , "GupPet_CheckButtonTemplate");
			end

			getglobal(MountType..i ):SetChecked( GUPPET_SAVEDDATA[MountType][ i ]["Weight"][ getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location ] );
			getglobal(MountType..i ):SetScript("OnClick", function (self)   
					if ( IsModifiedClick() ) then   
			
						self:SetChecked( not self:GetChecked() ) ;
			
						if ( IsModifiedClick("CHATLINK") ) then
							if ( MacroFrame and MacroFrame:IsShown() ) then
								local spellName = GetSpellInfo( GUPPET_SAVEDDATA[MountType][ i ]["Id"] );
								ChatEdit_InsertLink(spellName);
							else
								local spellLink = GetSpellLink( GUPPET_SAVEDDATA[MountType][ i ]["Id"] );
								ChatEdit_InsertLink(spellLink);
							end
						end
					else   
						GupPet_SetWeight( MountType , i , self:GetChecked() , getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location )   ;       
					end
				end);
						
		end
		
		getglobal(MountType..i ):SetPoint('TOPLEFT', 10, 15-(i*15));
		getglobal(MountType..i .. "Text"):SetText( GUPPET_SAVEDDATA[MountType][ i ]["Name"]  ) ;
		getglobal(MountType..i ):SetScript("OnEnter", function(self, button, down)	GupPet_PreviewModel:SetCreature( GUPPET_SAVEDDATA[MountType][ i ]["CreatureID"]  )	GupPet_Preview:Show() end);
		getglobal(MountType..i ):SetScript("OnLeave", function() GupPet_Preview:Hide()	end);	
	
		t_i = i ;
	end

	Data.Temp =  t_i ;


	local t_i = 0 ;

	for i = 1 , GUPPET_SAVEDDATA[ MountType ]["Total"]- math.ceil(GUPPET_SAVEDDATA[ MountType ]["Total"]/2) do

		local ii = i + math.ceil(GUPPET_SAVEDDATA[ MountType ]["Total"]/2) ;
	
		if GUPPET_OPTIONS.Mode == "Expert" then
			if ( Data.Temp < ii ) then

				Data[ii] = CreateFrame('Slider', MountType..ii , getglobal( MountType .. "Data") , 'GupPet_SliderTemplate');
				Data[ii]:SetMinMaxValues(0 , 10);
				Data[ii]:SetValueStep( 1) ;
			end
				
			getglobal(MountType..ii ):SetValue( GUPPET_SAVEDDATA[MountType][ ii ]["Weight"][ getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location ] );
			getglobal(MountType..ii ):SetScript("OnValueChanged", function (self)   GupPet_SetWeight( MountType , ii , self:GetValue() , getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location ) ;       end);
			 
		
		else 
			if ( Data.Temp < ii ) then

				Data[ii] = CreateFrame("CheckButton", MountType..ii , getglobal( MountType .. "Data") , "GupPet_CheckButtonTemplate");
			end

			getglobal(MountType..ii ):SetChecked( GUPPET_SAVEDDATA[MountType][ ii ]["Weight"][ getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location ] );
			getglobal(MountType..ii ):SetScript("OnClick", function (self) 
								
					if ( IsModifiedClick() ) then   
			
						self:SetChecked( not self:GetChecked() ) ;
			
						if ( IsModifiedClick("CHATLINK") ) then
							if ( MacroFrame and MacroFrame:IsShown() ) then
								local spellName = GetSpellInfo( GUPPET_SAVEDDATA[MountType][ ii ]["Id"] );
								ChatEdit_InsertLink(spellName);
							else
								local spellLink = GetSpellLink( GUPPET_SAVEDDATA[MountType][ ii ]["Id"] );
								ChatEdit_InsertLink(spellLink);
							end
						end
					else   
						GupPet_SetWeight( MountType , ii , self:GetChecked() , getglobal(GUPPET_INTERFACE_LOCATIONFRAME.Selected).Location )   ; 
					end       
			end);
		
		end
		
		getglobal(MountType..ii ):SetPoint('TOPLEFT', 236, 15-(i*15));
		getglobal(MountType..ii .. "Text"):SetText( GUPPET_SAVEDDATA[MountType][ ii ]["Name"]  ) ;
		getglobal(MountType..ii ):SetScript("OnEnter", function(self, button, down)	GupPet_PreviewModel:SetCreature( GUPPET_SAVEDDATA[MountType][ ii ]["CreatureID"]  )	GupPet_Preview:Show() end);
		getglobal(MountType..ii ):SetScript("OnLeave", function() GupPet_Preview:Hide()	end);	
	
		t_i = ii ;
	end	
	
	
	Data.Temp =  t_i ;
	
	

return Data

end







function GupPet_Interface_SortLocations (t)
	 
	local a = {}
		
	for n , v in pairs(t) do 
		
		q = { n = n , v = v } ;
	
		table.insert(a,q)   
	end
			
	table.sort(a,function(a,b)
					
		if b then
			if a["v"] == b["v"] then return a["n"]<b["n"] end 
			return a["v"] < b["v"]
		end
								
		return nil 
	end
	)
	
	local i = 0      -- iterator variable
	local iter = function ()   -- iterator function
		i = i + 1
		if a[i] == nil then return nil
		else return a[i]["n"], a[i]["v"]
		end
	end

	return iter
end

function GupPet_Interface_ScrollFrame_Update(frame, numItems, numToDisplay, valueStep , FrameWidth  )

	local frameName = frame:GetName();
	local scrollBar = getglobal( frameName.."ScrollBar" );
	local scrollChildFrame = getglobal( frameName.."ScrollChildFrame" );
	local scrollUpButton = getglobal( frameName.."ScrollBarScrollUpButton" );
	local scrollDownButton = getglobal( frameName.."ScrollBarScrollDownButton" );
	local scrollFrameHeight = 0;
	local scrollChildHeight = 0;

	if ( numItems > 0 ) then
		scrollFrameHeight = (numItems - numToDisplay) * valueStep;
		scrollChildHeight = numItems * valueStep;
		if ( scrollFrameHeight < 0 ) then
			scrollFrameHeight = 0;
		end
		scrollChildFrame:Show();
	else
		scrollChildFrame:Hide();
	end

	scrollBar:SetMinMaxValues(0, scrollFrameHeight); 
	scrollBar:SetValueStep(valueStep);
	scrollChildFrame:SetHeight(scrollChildHeight);
	
	if ( numItems > numToDisplay ) then
		scrollBar:Show();
		frame:SetWidth(FrameWidth-22) ;
	else
		frame:SetWidth(FrameWidth);
		scrollBar:Hide();
	end

	-- Arrow button handling
	if ( scrollBar:GetValue() == 0 ) then
		scrollUpButton:Disable();
	else
		scrollUpButton:Enable();
	end
		
	if ((scrollBar:GetValue() - scrollFrameHeight) == 0) then
		scrollDownButton:Disable();
	else
		scrollDownButton:Enable();
	end

end


function GupPet_Interface_IngameButtons_UpdateIcons()

 	getglobal("GupPet_IngameFrameTemplateAutoIcon"):SetTexture( GUPPET_OPTIONS.IngameButton.Icons.Auto );
	getglobal("GupPet_IngameFrameTemplateGroundIcon"):SetTexture( GUPPET_OPTIONS.IngameButton.Icons.Ground ) ;
	getglobal("GupPet_IngameFrameTemplateFlyIcon"):SetTexture( GUPPET_OPTIONS.IngameButton.Icons.Fly) ;
	getglobal("GupPet_IngameFrameTemplateCompanionIcon"):SetTexture( GUPPET_OPTIONS.IngameButton.Icons.Companion) ;
	
end


--[[ 
	Make a nice interface to select your own icon
	]]

	
	-- WORK IN PROGRESS !!!!!!!!!!!!
function GupPet_Interface_IngameButtons_ChangeIcons()

	local temp = {} ;
	local temp_ = GetNumMacroIcons();
	
	for i=1 , temp_ / 10 do
				
		for j=1 , 10 do
		
		temp[j] = CreateFrame("Button", "GupPet_Icon"..i..j , GupPet_InterfaceIconFrameDatafieldData , "GupPet_IconTemplate");
		getglobal( "GupPet_Icon"..i..j ):SetPoint('TOPLEFT', -25+(j*25) , 25-(i*25));
		getglobal( "GupPet_Icon"..i..j.."Icon" ):SetTexture(  GetMacroIconInfo(-10+(10*i)+j) );
		
		end
				
	end ;
			
	GupPet_Interface_ScrollFrame_Update( getglobal("GupPet_InterfaceIconFrameDatafieldContainer") , floor( temp_ / 10) , 10 , 25 , 270);			
end
